
#include "spca5xx.h"


int spca5xx_get_depth(struct usb_spca50x *spca50x, int palette);
int spca5xx_getDefaultMode(struct usb_spca50x *spca50x);
void spca5xx_setFrameDecoder(struct usb_spca50x *spca50x);
int spca5xx_restartMode(struct usb_spca50x *spca50x, int width, int height, int format);
int spca50x_init_source(struct usb_spca50x *spca50x);

int spca5xx_setMode(struct usb_spca50x *spca50x, int width, int height, int format);

static inline int v4l_to_spca5xx(int format)
{
	switch (format) {
	case VIDEO_PALETTE_RGB565:
		return P_RGB16;
	case VIDEO_PALETTE_RGB24:
		return P_RGB24;
	case VIDEO_PALETTE_RGB32:
		return P_RGB32;
	case VIDEO_PALETTE_YUV422P:
		return P_YUV422;
	case VIDEO_PALETTE_YUV420P:
		return P_YUV420;
	case VIDEO_PALETTE_RAW_JPEG:
		return P_RAW;
	case VIDEO_PALETTE_JPEG:
		return P_JPEG;
	default:
		return -EINVAL;
	}
}

