#ifndef __MAIN_H__
#define __MAIN_H__


#include "print_xxx.h"	/* for log */

#define VIDEO_PALETTE_JPEG 21	/* for jpeg img with header */
#define JPEG_FORMAT_DEPTH 8	/* jpeg palette depth */


struct zc3xx_cam { 
	int cfd; 	/* zc3xx webcam device file descriptor */
	int width;
	int height;
	int format;
	int max_img_num;
	int overwrite;	/* 0:disable 1:enable */
	unsigned int img_len;
	unsigned char* img_buf;
	unsigned char* devpath;
	unsigned char* filename;
	struct video_mmap vmmap;
	struct video_capability videocap;
	struct video_mbuf videombuf;
	struct video_picture videopict;
	struct video_window videowin;
	struct video_channel videochan;
};

struct pic_struct { 
	int overwrite;	/* 0:disable 1:enable */
	unsigned int size;
	unsigned char issave;
	unsigned char* buf;
	unsigned char* filename;
	pthread_t th_id;
	pthread_mutex_t mutex;
	pthread_cond_t cond;
};

int set_vd_size(struct zc3xx_cam *cam, int width, int height);
int grab_init(struct zc3xx_cam *cam);


int start_save_thread(struct pic_struct* pic, char* filename, unsigned int size);
void stop_save_thread(struct pic_struct* pic);
int request_save_img(struct pic_struct* pic);
#endif
